commit:     6744186d10bceadab7c2a4f5bc5c616d655877f7
Author:     Sam James <sam <AT> gentoo <DOT> org>
AuthorDate: Sat Dec  3 05:01:15 2022 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Sat Dec  3 06:06:06 2022 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=6744186d

sys-devel/gdb: fix configure w/ clang 16

Doesn't fix the other build problems yet, but given that implicit. func.
decls can affect all compilers...

Bug: https://bugs.gentoo.org/871543
Signed-off-by: Sam James <sam <AT> gentoo.org>

 .../gdb/files/gdb-12.1-configure-clang16.patch     | 112 ++++++++
 sys-devel/gdb/gdb-12.1-r3.ebuild                   | 295 +++++++++++++++++++++
 2 files changed, 407 insertions(+)

diff --git a/sys-devel/gdb/files/gdb-12.1-configure-clang16.patch 
b/sys-devel/gdb/files/gdb-12.1-configure-clang16.patch
new file mode 100644
index 000000000000..3b2c15de4895
--- /dev/null
+++ b/sys-devel/gdb/files/gdb-12.1-configure-clang16.patch
@@ -0,0 +1,112 @@
+https://sourceware.org/git/?p=binutils-gdb.git;a=commit;h=0075c53724f78c78aa1692cc8e3bf1433eeb0b9f
+https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=885b6660c17fb91980b5682514ef54668e544b02
+https://bugzilla.redhat.com/show_bug.cgi?id=2143992
+
+From FEDORA_PATCHES Mon Sep 17 00:00:00 2001
+From: Keith Seitz <kei...@redhat.com>
+Date: Tue, 29 Nov 2022 13:43:34 -0800
+Subject: gdb-rhbz2143992-libiberty-fix-c89isms-in-configure.patch
+
+;; libiberty: Fix C89-isms in configure tests
+;; (Florian Weimer, RHBZ 2143992)
+
+    libiberty/
+
+            * acinclude.m4 (ac_cv_func_strncmp_works): Add missing
+            int return type and parameter list to the definition of main.
+            Include <stdlib.h> and <string.h> for prototypes.
+            (ac_cv_c_stack_direction): Add missing
+            int return type and parameter list to the definitions of
+            main, find_stack_direction.  Include <stdlib.h> for exit
+            prototype.
+            * configure: Regenerate.
+
+--- a/libiberty/acinclude.m4
++++ b/libiberty/acinclude.m4
+@@ -24,6 +24,8 @@ AC_CACHE_CHECK([for working strncmp], 
ac_cv_func_strncmp_works,
+ [AC_TRY_RUN([
+ /* Test by Jim Wilson and Kaveh Ghazi.
+    Check whether strncmp reads past the end of its string parameters. */
++#include <stdlib.h>
++#include <string.h>
+ #include <sys/types.h>
+ 
+ #ifdef HAVE_FCNTL_H
+@@ -51,7 +53,8 @@ AC_CACHE_CHECK([for working strncmp], 
ac_cv_func_strncmp_works,
+ 
+ #define MAP_LEN 0x10000
+ 
+-main ()
++int
++main (void)
+ {
+ #if defined(HAVE_MMAP) || defined(HAVE_MMAP_ANYWHERE)
+   char *p;
+@@ -157,7 +160,10 @@ if test $ac_cv_os_cray = yes; then
+ fi
+ 
+ AC_CACHE_CHECK(stack direction for C alloca, ac_cv_c_stack_direction,
+-[AC_TRY_RUN([find_stack_direction ()
++[AC_TRY_RUN([#include <stdlib.h>
++
++int
++find_stack_direction (void)
+ {
+   static char *addr = 0;
+   auto char dummy;
+@@ -169,7 +175,9 @@ AC_CACHE_CHECK(stack direction for C alloca, 
ac_cv_c_stack_direction,
+   else
+     return (&dummy > addr) ? 1 : -1;
+ }
+-main ()
++
++int
++main (void)
+ {
+   exit (find_stack_direction() < 0);
+ }],
+--- a/libiberty/configure
++++ b/libiberty/configure
+@@ -6918,7 +6918,10 @@ else
+ else
+   cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+ /* end confdefs.h.  */
+-find_stack_direction ()
++#include <stdlib.h>
++
++int
++find_stack_direction (void)
+ {
+   static char *addr = 0;
+   auto char dummy;
+@@ -6930,7 +6933,9 @@ find_stack_direction ()
+   else
+     return (&dummy > addr) ? 1 : -1;
+ }
+-main ()
++
++int
++main (void)
+ {
+   exit (find_stack_direction() < 0);
+ }
+@@ -7755,6 +7760,8 @@ else
+ 
+ /* Test by Jim Wilson and Kaveh Ghazi.
+    Check whether strncmp reads past the end of its string parameters. */
++#include <stdlib.h>
++#include <string.h>
+ #include <sys/types.h>
+ 
+ #ifdef HAVE_FCNTL_H
+@@ -7782,7 +7789,8 @@ else
+ 
+ #define MAP_LEN 0x10000
+ 
+-main ()
++int
++main (void)
+ {
+ #if defined(HAVE_MMAP) || defined(HAVE_MMAP_ANYWHERE)
+   char *p;
+

diff --git a/sys-devel/gdb/gdb-12.1-r3.ebuild b/sys-devel/gdb/gdb-12.1-r3.ebuild
new file mode 100644
index 000000000000..d488fd670d9c
--- /dev/null
+++ b/sys-devel/gdb/gdb-12.1-r3.ebuild
@@ -0,0 +1,295 @@
+# Copyright 1999-2022 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+PYTHON_COMPAT=( python3_{8..11} )
+inherit flag-o-matic python-single-r1 strip-linguas toolchain-funcs
+
+export CTARGET=${CTARGET:-${CHOST}}
+
+if [[ ${CTARGET} == ${CHOST} ]] ; then
+       if [[ ${CATEGORY} == cross-* ]] ; then
+               export CTARGET=${CATEGORY#cross-}
+       fi
+fi
+
+is_cross() { [[ ${CHOST} != ${CTARGET} ]] ; }
+
+case ${PV} in
+       9999*)
+               # live git tree
+               EGIT_REPO_URI="https://sourceware.org/git/binutils-gdb.git";
+               inherit git-r3
+               SRC_URI=""
+               ;;
+       *.*.50.2???????)
+               # weekly snapshots
+               
SRC_URI="ftp://sourceware.org/pub/gdb/snapshots/current/gdb-weekly-${PV}.tar.xz";
+               ;;
+       *)
+               # Normal upstream release
+               SRC_URI="mirror://gnu/gdb/${P}.tar.xz
+                       ftp://sourceware.org/pub/gdb/releases/${P}.tar.xz";
+               ;;
+esac
+
+DESCRIPTION="GNU debugger"
+HOMEPAGE="https://sourceware.org/gdb/";
+SRC_URI="${SRC_URI}
+       
${PATCH_DEV:+https://dev.gentoo.org/~${PATCH_DEV}/distfiles/${P}-patches-${PATCH_VER}.tar.xz}
+       ${PATCH_VER:+mirror://gentoo/${P}-patches-${PATCH_VER}.tar.xz}"
+
+LICENSE="GPL-3+ LGPL-2.1+"
+SLOT="0"
+
+if [[ ${PV} != 9999* ]] ; then
+       KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 
~riscv ~s390 ~sparc ~x86 ~x64-cygwin ~amd64-linux ~x86-linux ~x64-macos 
~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
+fi
+
+IUSE="cet guile lzma multitarget nls +python +server source-highlight test 
vanilla xml xxhash"
+REQUIRED_USE="python? ( ${PYTHON_REQUIRED_USE} )"
+
+# In fact, gdb's test suite needs some work to get passing.
+# See e.g. https://sourceware.org/gdb/wiki/TestingGDB.
+# As of 11.2, on amd64: "# of unexpected failures    8600"
+# ia64 kernel crashes when gdb testsuite is running
+# in fact, gdb's test suite needs some work to get passing.
+# See e.g. https://sourceware.org/gdb/wiki/TestingGDB.
+# As of 11.2, on amd64: "# of unexpected failures    8600"
+RESTRICT="
+       ia64? ( test )
+       !test? ( test )
+       test
+"
+
+RDEPEND="
+       dev-libs/mpfr:0=
+       dev-libs/gmp:=
+       >=sys-libs/ncurses-5.2-r2:0=
+       >=sys-libs/readline-7:0=
+       sys-libs/zlib
+       elibc_glibc? ( net-libs/libnsl:= )
+       lzma? ( app-arch/xz-utils )
+       python? ( ${PYTHON_DEPS} )
+       guile? ( >=dev-scheme/guile-2.0 )
+       xml? ( dev-libs/expat )
+       source-highlight? (
+               dev-util/source-highlight
+       )
+       xxhash? (
+               dev-libs/xxhash
+       )
+"
+DEPEND="${RDEPEND}"
+BDEPEND="
+       app-arch/xz-utils
+       sys-apps/texinfo
+       app-alternatives/yacc
+       nls? ( sys-devel/gettext )
+       source-highlight? ( virtual/pkgconfig )
+       test? ( dev-util/dejagnu )
+"
+
+PATCHES=(
+       "${FILESDIR}"/${PN}-8.3.1-verbose-build.patch
+       "${FILESDIR}"/${P}-readline-8.2-build.patch
+       "${FILESDIR}"/${P}-core-file-detach.patch
+       "${FILESDIR}"/${P}-configure-clang16.patch
+)
+
+pkg_setup() {
+       use python && python-single-r1_pkg_setup
+}
+
+src_prepare() {
+       default
+
+       strip-linguas -u bfd/po opcodes/po
+
+       # Avoid using ancient termcap from host on Prefix systems
+       sed -i -e 's/termcap tinfow/tinfow/g' \
+               gdb/configure{.ac,} || die
+}
+
+gdb_branding() {
+       printf "Gentoo ${PV} "
+
+       if ! use vanilla && [[ -n ${PATCH_VER} ]] ; then
+               printf "p${PATCH_VER}"
+       else
+               printf "vanilla"
+       fi
+
+       [[ -n ${EGIT_COMMIT} ]] && printf " ${EGIT_COMMIT}"
+}
+
+src_configure() {
+       strip-unsupported-flags
+
+       # See 
https://www.gnu.org/software/make/manual/html_node/Parallel-Output.html
+       # Avoid really confusing logs from subconfigure spam, makes logs far
+       # more legible.
+       MAKEOPTS="--output-sync=line ${MAKEOPTS}"
+
+       local myconf=(
+               # portage's econf() does not detect presence of --d-d-t
+               # because it greps only top-level ./configure. But not
+               # gnulib's or gdb's configure.
+               --disable-dependency-tracking
+
+               --with-pkgversion="$(gdb_branding)"
+               --with-bugurl='https://bugs.gentoo.org/'
+               --disable-werror
+               # Disable modules that are in a combined binutils/gdb tree. bug 
#490566
+               --disable-{binutils,etc,gas,gold,gprof,ld}
+
+               # avoid automagic dependency on (currently prefix) systems
+               # systems with debuginfod library, bug #754753
+               --without-debuginfod
+
+               $(use_enable test unit-tests)
+
+               # Allow user to opt into CET for host libraries.
+               # Ideally we would like automagic-or-disabled here.
+               # But the check does not quite work on i686: bug #760926.
+               $(use_enable cet)
+
+               # We need to set both configure options, --with-sysroot and 
--libdir,
+               # to fix cross build issues that happen when configuring gmp.
+               # We explicitly need --libdir. Having only --with-sysroot 
without
+               # --libdir would not fix the build issues.
+               # For some reason, it is not enough to set only --with-sysroot,
+               # also not enough to pass --with-gmp-xxx options.
+               --with-sysroot="${ESYSROOT}"
+               --libdir="${ESYSROOT}/usr/$(get_libdir)"
+       )
+
+       local sysroot="${EPREFIX}/usr/${CTARGET}"
+
+       is_cross && myconf+=(
+               --with-sysroot="${sysroot}"
+               --includedir="${sysroot}/usr/include"
+               --with-gdb-datadir="\${datadir}/gdb/${CTARGET}"
+       )
+
+       # gdbserver only works for native targets (CHOST==CTARGET).
+       # it also doesn't support all targets, so rather than duplicate
+       # the target list (which changes between versions), use the
+       # "auto" value when things are turned on, which is triggered
+       # whenever no --enable or --disable is given
+       if is_cross || use !server ; then
+               myconf+=( --disable-gdbserver )
+       fi
+
+       myconf+=(
+               --enable-64-bit-bfd
+               --disable-install-libbfd
+               --disable-install-libiberty
+               --enable-obsolete
+               # This only disables building in the readline subdir.
+               # For gdb itself, it'll use the system version.
+               --disable-readline
+               --with-system-readline
+               # This only disables building in the zlib subdir.
+               # For gdb itself, it'll use the system version.
+               --without-zlib
+               --with-system-zlib
+               --with-separate-debug-dir="${EPREFIX}"/usr/lib/debug
+               $(use_with xml expat)
+               $(use_with lzma)
+               $(use_enable nls)
+               $(use_enable source-highlight)
+               $(use multitarget && echo --enable-targets=all)
+               $(use_with python python "${EPYTHON}")
+               $(use_with xxhash)
+               $(use_with guile)
+       )
+
+       if use sparc-solaris || use x86-solaris ; then
+               # Disable largefile support
+               # https://sourceware.org/ml/gdb-patches/2014-12/msg00058.html
+               myconf+=( --disable-largefile )
+       fi
+
+       # source-highlight is detected with pkg-config: bug #716558
+       export ac_cv_path_pkg_config_prog_path="$(tc-getPKG_CONFIG)"
+
+       export CC_FOR_BUILD="$(tc-getBUILD_CC)"
+
+       # ensure proper compiler is detected for Clang builds: bug #831202
+       export GCC_FOR_TARGET="${CC_FOR_TARGET:-$(tc-getCC)}"
+
+       econf "${myconf[@]}"
+}
+
+src_compile() {
+       emake V=1
+}
+
+src_install() {
+       emake V=1 DESTDIR="${D}" install
+
+       find "${ED}"/usr -name libiberty.a -delete || die
+
+       # Delete translations that conflict with binutils-libs. bug #528088
+       # Note: Should figure out how to store these in an internal gdb dir.
+       if use nls ; then
+               find "${ED}" \
+                       -regextype posix-extended -regex 
'.*/(bfd|opcodes)[.]g?mo$' \
+                       -delete || die
+       fi
+
+       # Don't install docs when building a cross-gdb
+       if [[ ${CTARGET} != ${CHOST} ]] ; then
+               rm -rf "${ED}"/usr/share/{doc,info,locale} || die
+               local f
+               for f in "${ED}"/usr/share/man/*/* ; do
+                       if [[ ${f##*/} != ${CTARGET}-* ]] ; then
+                               mv "${f}" "${f%/*}/${CTARGET}-${f##*/}" || die
+                       fi
+               done
+               return 0
+       fi
+
+       # Install it by hand for now:
+       # https://sourceware.org/ml/gdb-patches/2011-12/msg00915.html
+       # Only install if it exists due to the twisted behavior (see
+       # notes in src_configure above).
+       [[ -e gdbserver/gdbreplay ]] && dobin gdbserver/gdbreplay
+
+       docinto gdb
+       dodoc gdb/CONTRIBUTE gdb/README gdb/MAINTAINERS \
+               gdb/NEWS gdb/PROBLEMS
+       docinto sim
+       dodoc sim/{MAINTAINERS,README-HACKING}
+
+       if use server ; then
+               docinto gdbserver
+               dodoc gdbserver/README
+       fi
+
+       if [[ -n ${PATCH_VER} ]] ; then
+               dodoc "${WORKDIR}"/extra/gdbinit.sample
+       fi
+
+       # Remove shared info pages
+       rm -f 
"${ED}"/usr/share/info/{annotate,bfd,configure,ctf-spec,standards}.info*
+
+       if use python ; then
+               python_optimize "${ED}"/usr/share/gdb/python/gdb
+       fi
+}
+
+pkg_postinst() {
+       # Portage doesn't unmerge files in /etc
+       rm -vf "${EROOT}"/etc/skel/.gdbinit
+
+       if use prefix && [[ ${CHOST} == *-darwin* ]] ; then
+               ewarn "gdb is unable to get a mach task port when installed by 
Prefix"
+               ewarn "Portage, unprivileged.  To make gdb fully functional 
you'll"
+               ewarn "have to perform the following steps:"
+               ewarn "  % sudo chgrp procmod ${EPREFIX}/usr/bin/gdb"
+               ewarn "  % sudo chmod g+s ${EPREFIX}/usr/bin/gdb"
+       fi
+}

Reply via email to